## taskflow 3.6.0%2Bds

=== examples/CMakeLists.txt ===
list(APPEND TF_EXAMPLES
  simple 
  attach_data
  async
  subflow_async
  dependent_async
  observer 
  subflow 
  fibonacci 
  condition
  multi_condition
  switch_case
  do_while_loop
  while_loop
  if_else
  nested_if_else
  priority
  visualization 
  parallel_for 
  parallel_sort
  reduce 
  inclusive_scan
  exclusive_scan
  pipeline
  scalable_pipeline
  scalable_pipeline_with_deferred_tokens
  text_pipeline
  taskflow_pipeline
  parallel_graph_pipeline
  parallel_data_pipeline
  pipeline_with_deferred_tokens
  run 
  corun
  runtime
  worker_interface
  composition
  limited_concurrency
  cancel
)

foreach(example IN LISTS TF_EXAMPLES)
  add_executable(${example} ${example}.cpp)
  target_link_libraries(
    ${example} ${PROJECT_NAME} tf::default_settings
    )
  # set emcc options
  if (CMAKE_SYSTEM_NAME STREQUAL Emscripten)
    target_link_options(${example} PUBLIC -sASSERTIONS=1 -sPROXY_TO_PTHREAD -sTOTAL_MEMORY=1536MB -sEXIT_RUNTIME=1 -sUSE_PTHREADS=1)
    target_compile_options(${example} PUBLIC -matomics)
  endif()
endforeach()

# -----------------------------------------------------------------------------
# cuda examples
# -----------------------------------------------------------------------------
if(TF_BUILD_CUDA)
  add_subdirectory(cuda)
endif()

# -----------------------------------------------------------------------------
# sycl examples
# -----------------------------------------------------------------------------
if(TF_BUILD_SYCL)
  add_subdirectory(sycl)
endif()


#### TensorFrame Project
##set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${TF_EXAMPLE_DIR}/tensorframe)
#add_executable(add ${TF_EXAMPLE_DIR}/tensorframe/add.cpp)
#target_link_libraries(
#  add TensorFrame Threads::Threads tf::default_settings
#)


#### TaskflowDSL project
#### TODO: enable only when C++17 is available
##set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${TF_EXAMPLE_DIR}/dsl)
#add_executable(condition_dsl ${TF_EXAMPLE_DIR}/dsl/condition_dsl.cpp)
#target_link_libraries(
#  condition_dsl TaskflowDSL tf::default_settings
#)
#
#add_executable(simple_dsl ${TF_EXAMPLE_DIR}/dsl/simple_dsl.cpp)
#target_link_libraries(
#  simple_dsl TaskflowDSL tf::default_settings
#)
#
#add_executable(visualization_dsl ${TF_EXAMPLE_DIR}/dsl/visualization_dsl.cpp)
#target_link_libraries(
#  visualization_dsl TaskflowDSL tf::default_settings
#)

=== debian/changelog ===
taskflow (3.6.0+ds-6) unstable; urgency=medium

  * Make libtaskflow-cpp-dev an arch-any package, as the CMake files
    record whether the machine is 32 or 64 bit
  * Improve the build system correspondingly

 -- Julian Gilbey <jdg@debian.org>  Mon, 22 Apr 2024 10:16:09 +0100

taskflow (3.6.0+ds-5) unstable; urgency=medium

  * Remove ${ATOMIC_LIBRARY} from autopkgtest call; it should not be
    necessary (and is not defined anywhere)

 -- Julian Gilbey <jdg@debian.org>  Sun, 21 Apr 2024 20:07:03 +0100

taskflow (3.6.0+ds-4) unstable; urgency=medium

  * Check for correct flags for libatomic to fix build failure on armel

 -- Julian Gilbey <jdg@debian.org>  Sun, 21 Apr 2024 17:57:40 +0100

taskflow (3.6.0+ds-3) unstable; urgency=medium

  * Fix arch-indep build-deps

 -- Julian Gilbey <jdg@debian.org>  Fri, 19 Apr 2024 07:11:30 +0100

taskflow (3.6.0+ds-2) unstable; urgency=medium

  * Source-only upload.

 -- Julian Gilbey <jdg@debian.org>  Thu, 18 Apr 2024 20:02:18 +0100

taskflow (3.6.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1064473)

 -- Julian Gilbey <jdg@debian.org>  Wed, 06 Mar 2024 08:46:23 +0000

## taskflow 3.6.0+ds

=== CMakeLists.txt ===
# -------------------------------------------------------------------
# Taskflow CMake 
#
# To enable thread sanitizer: 
# -DCMAKE_CXX_FLAGS="-fsanitize=thread -g"
#
# To enable address and leak sanitizers
# -DCMAKE_CXX_FLAGS="-fsanitize=address  -fsanitize=leak -g"
# -------------------------------------------------------------------


# CMake version
cmake_minimum_required (VERSION 3.18)
MESSAGE(STATUS "CMAKE_ROOT: " ${CMAKE_ROOT})

# Project name
project(Taskflow VERSION 3.6.0 LANGUAGES CXX)

# build options
option(TF_BUILD_BENCHMARKS "Enables builds of benchmarks" OFF)
option(TF_BUILD_CUDA "Enables builds of cuda code" OFF)
option(TF_BUILD_SYCL "Enables builds of sycl code" OFF)
option(TF_BUILD_TESTS "Enables builds of tests" ON)
option(TF_BUILD_EXAMPLES "Enables builds of examples" ON)

# project-specific variables
set(TF_UTEST_DIR ${PROJECT_SOURCE_DIR}/unittests)
set(TF_EXAMPLE_DIR ${PROJECT_SOURCE_DIR}/examples)
set(TF_BENCHMARK_DIR ${PROJECT_SOURCE_DIR}/benchmarks)
set(TF_3RD_PARTY_DIR ${PROJECT_SOURCE_DIR}/3rd-party)
set(TF_CMAKE_DIR ${PROJECT_SOURCE_DIR}/cmake)
set(TF_DEFAULT_BUILD_TYPE "Release")

# Turn on the verbose
set(CMAKE_VERBOSE_MAKEFILE ON)

# Include additional language check
include(CheckLanguage)

# Adhere to GNU conventions
include(GNUInstallDirs)

# Compiler vendors
## g++
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "7.0")
    message(STATUS "CMAKE_CXX_COMPILER_VERSION: ${CMAKE_CXX_COMPILER_VERSION}")
    message(FATAL_ERROR "\nTaskflow requires g++ at least v7.0")
  endif()
## clang++
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "6.0")
    message(STATUS "CMAKE_CXX_COMPILER_VERSION: ${CMAKE_CXX_COMPILER_VERSION}")
    message(FATAL_ERROR "\nTaskflow requires clang++ at least v6.0")
  endif() 
## AppleClang
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.0")
    message(FATAL_ERROR "\nTaskflow requires AppleClang at least v8.0")
  endif()
## microsoft visual c++
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  add_definitions(/bigobj)
  if(NOT MSVC_VERSION GREATER_EQUAL 1914)
    message(STATUS "CMAKE_CXX_COMPILER_VERSION: ${CMAKE_CXX_COMPILER_VERSION}")
    message(FATAL_ERROR "\nTaskflow requires MSVC++ at least v14.14") 
  endif()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "19.0.1")
    message(STATUS "CMAKE_CXX_COMPILER_VERSION: ${CMAKE_CXX_COMPILER_VERSION}")
    message(FATAL_ERROR "\nTaskflow requires icpc at least v19.0.1")
  endif()
else()
  message(FATAL_ERROR "\n\
Taskflow currently supports the following compilers:\n\
  - g++ v7.0 or above\n\
  - clang++ v6.0 or above\n\
  - MSVC++ v19.14 or above\n\
  - AppleClang v8 or above\n\
  - Intel v19.0.1 or above\n\
")
endif()

# -----------------------------------------------------------------------------
# find nvcc
# https://cliutils.gitlab.io/modern-cmake/chapters/packages/CUDA.html
# -----------------------------------------------------------------------------
if(TF_BUILD_CUDA)
  message(STATUS "Configuring CUDA ...")
  check_language(CUDA)
  if(NOT CMAKE_CUDA_COMPILER)
    message(FATAL_ERROR "\nNo CUDA compiler found")
  endif()
  enable_language(CUDA)
  if(CMAKE_CUDA_COMPILER_VERSION VERSION_LESS "11")
    message(STATUS "CMAKE_CUDA_COMPILER_VERSION: ${CMAKE_CUDA_COMPILER_VERSION}")
    message(FATAL_ERROR "\nTaskflow requires CUDA at least v11")
  endif()
  
  ## configure cuBLAS
  #message(STATUS "Configuring CUDA BLAS ...")
  #list(APPEND CMAKE_MODULE_PATH ${TF_CMAKE_DIR}/cuda/modules/)
  #find_package(cuBLAS)
  #message(STATUS "CUBLAS_FOUND: ${CUBLAS_FOUND}")
  #message(STATUS "CUBLAS_INCLUDE_DIRS: ${CUBLAS_INCLUDE_DIRS}")
  #message(STATUS "CUBLAS_LIBRARIES: ${CUBLAS_LIBRARIES}")
endif()

# -----------------------------------------------------------------------------
# find ComputeCpp
# https://developer.codeplay.com/products/computecpp/ce/guides/integration-guide
# -----------------------------------------------------------------------------
# Users can specify:
# 1. -DComputeCpp_DIR=/path/to/ComputeCpp/
# 2. -DCOMPUTECPP_BITCODE=ptx64 (default spir64)
# For example:
# cmake ../ -DTF_BUILD_SYCL=ON 
#           -DCOMPUTECPP_BITCODE=ptx64 
#           -DComputeCpp_DIR=$COMPUTECPP_HOME
#if(TF_BUILD_SYCL)
#  message(STATUS "Configuring ComputeCpp for SYCL ...")
#  message(STATUS "You may specify '-DComputeCpp_DIR=/path/to/ComputeCpp/'")
#  message(STATUS "You may specify '-DCOMPUTECPP_BITCODE=ptx64' for Nvidia devices")
#  list(APPEND CMAKE_MODULE_PATH ${TF_CMAKE_DIR}/ComputeCpp/Modules/)
#  if(NOT ComputeCpp_DIR)
#    message(FATAL_ERROR "Please specify -DComputeCpp_DIR=/path/to/ComputeCpp/")
#  endif()
#  find_package(ComputeCpp REQUIRED)
#  message(STATUS "ComputeCpp_DIR: " ${ComputeCpp_DIR})
#  message(STATUS "ComputeCpp_INCLUDE_DIRS: " ${ComputeCpp_INCLUDE_DIRS})
#  include_directories(${ComputeCpp_INCLUDE_DIRS})
#endif()

# -----------------------------------------------------------------------------
# defult release build
# -----------------------------------------------------------------------------
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${TF_DEFAULT_BUILD_TYPE}'")
  set(
    CMAKE_BUILD_TYPE "${TF_DEFAULT_BUILD_TYPE}" 
    CACHE
    STRING "Choose the type of build." 
    FORCE
  )
  # Set the possible values of build type for cmake-gui
  set_property(
    CACHE 
    CMAKE_BUILD_TYPE 
    PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo"
  )
endif()


# -----------------------------------------------------------------------------
# tf::default_setting
# -----------------------------------------------------------------------------

# error setting
add_library(error_settings INTERFACE)
add_library(tf::error_settings ALIAS error_settings)

target_compile_options(
  error_settings
  INTERFACE
  $<$<CXX_COMPILER_ID:AppleClang>:-Wall -Wextra -Wfatal-errors>
  $<$<AND:$<COMPILE_LANGUAGE:CXX>,$<CXX_COMPILER_ID:Clang>>:-Wall -Wextra -Wfatal-errors>
  $<$<AND:$<COMPILE_LANGUAGE:CXX>,$<CXX_COMPILER_ID:GNU>>:-Wall -Wextra -Wfatal-errors>
  $<$<AND:$<COMPILE_LANGUAGE:CXX>,$<CXX_COMPILER_ID:MSVC>>:/W3 /permissive->
)

# cuda compiler options
if(TF_BUILD_CUDA)
  message(STATUS "Configuring CUDA compiler options ...")
  target_compile_options(
    error_settings
    BEFORE
    INTERFACE
    $<$<COMPILE_LANGUAGE:CUDA>:--extended-lambda -Xcompiler=-Wall,-Wextra,-Wfatal-errors>
  )
endif(TF_BUILD_CUDA)

# sycl compiler options (currently support only DPC++)
if(TF_BUILD_SYCL)
  message(STATUS "Configuring SYCL compiler options ...")
  message(STATUS "You may specify -DTF_BUILD_SYCL_BITCODE=ptx64 for CUDA devices")
  list(APPEND TF_SYCL_OPTIONS -fsycl -fsycl-unnamed-lambda)
  if(TF_BUILD_SYCL_BITCODE STREQUAL "ptx64")
    message(STATUS "Configuring SYCL compiler options to CUDA ptx64 ...")
    list(APPEND TF_SYCL_OPTIONS -fsycl-targets=nvptx64-nvidia-cuda)
  endif()
endif()

# additional features
#add_library(features_settings INTERFACE)
#add_library(tf::features_settings ALIAS features_settings)
#target_compile_definitions(
#  features_settings 
#  INTERFACE 
#  $<$<CXX_COMPILER_ID:MSVC>:_ENABLE_EXTENDED_ALIGNED_STORAGE>
#)

# optimization
#
##! Msvc flags info
# /Zi - Produces a program database (PDB) that contains type information 
#       and symbolic debugging information for use with the debugger.
# /FS - Allows multiple cl.exe processes to write to the same .pdb file
# /DEBUG - Enable debug during linking
# /Od - Disables optimization
# /Ox - Full optimization
# /Oy- do not suppress frame pointers (recommended for debugging)
#
#add_library(optimize_settings INTERFACE)
#add_library(tf::optimize_settings ALIAS optimize_settings)
#
#target_compile_options(
#  optimize_settings INTERFACE
#  $<$<AND:$<CONFIG:Release>,$<CXX_COMPILER_ID:Clang>>:-O2 -march=native>
#  #$<$<AND:$<CONFIG:Release>,$<CXX_COMPILER_ID:AppleClang>>:-O2 -march=native>
#  $<$<AND:$<CONFIG:Release>,$<CXX_COMPILER_ID:GNU>>:-O2 -march=native>
#  $<$<AND:$<CONFIG:Release>,$<CXX_COMPILER_ID:MSVC>>:/O2 -DNDEBUG /MP>
#  $<$<AND:$<CONFIG:Debug>,$<CXX_COMPILER_ID:GNU>>:-O0 -g>
#  $<$<AND:$<CONFIG:Debug>,$<CXX_COMPILER_ID:Clang>>:-O0 -g>
#  #$<$<AND:$<CONFIG:Debug>,$<CXX_COMPILER_ID:AppleClang>>:-O0 -g>
#  $<$<AND:$<CONFIG:Debug>,$<CXX_COMPILER_ID:MSVC>>:/Zi /FS /DEBUG /Od /MP /MDd /Oy->
#)
#
add_library(default_settings INTERFACE)
add_library(tf::default_settings ALIAS default_settings)
target_link_libraries(
  default_settings 
  INTERFACE 
  tf::error_settings 
  #tf::optimize_settings 
  #tf::features_settings
)

# -----------------------------------------------------------------------------
# start build
# -----------------------------------------------------------------------------

message(STATUS "PROJECT_NAME: " ${PROJECT_NAME})
message(STATUS "CMAKE_HOST_SYSTEM: ${CMAKE_HOST_SYSTEM}")
message(STATUS "CMAKE_BUILD_TYPE: " ${CMAKE_BUILD_TYPE})
message(STATUS "CMAKE_CXX_COMPILER: " ${CMAKE_CXX_COMPILER})
message(STATUS "CMAKE_CXX_COMPILER_ID: " ${CMAKE_CXX_COMPILER_ID})
message(STATUS "CMAKE_CXX_COMPILER_VERSION: " ${CMAKE_CXX_COMPILER_VERSION})
message(STATUS "CMAKE_CXX_FLAGS: " ${CMAKE_CXX_FLAGS})
message(STATUS "CMAKE_CUDA_COMPILER: " ${CMAKE_CUDA_COMPILER})
message(STATUS "CMAKE_CUDA_COMPILER_ID: " ${CMAKE_CUDA_COMPILER_ID})
message(STATUS "CMAKE_CUDA_COMPILER_VERSION: " ${CMAKE_CUDA_COMPILER_VERSION})
message(STATUS "CMAKE_CUDA_FLAGS: " ${CMAKE_CUDA_FLAGS})
message(STATUS "CMAKE_MODULE_PATH: " ${CMAKE_MODULE_PATH})
message(STATUS "CMAKE_CURRENT_SOURCE_DIR: " ${CMAKE_CURRENT_SOURCE_DIR})
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})
message(STATUS "CMAKE_CURRENT_LIST_DIR: " ${CMAKE_CURRENT_LIST_DIR})
message(STATUS "CMAKE_EXE_LINKER_FLAGS: " ${CMAKE_EXE_LINKER_FLAGS})
message(STATUS "CMAKE_INSTALL_PREFIX: " ${CMAKE_INSTALL_PREFIX})
message(STATUS "CMAKE_INSTALL_FULL_INCLUDEDIR: " ${CMAKE_INSTALL_FULL_INCLUDEDIR})
message(STATUS "CMAKE_INSTALL_FULL_LIBDIR: " ${CMAKE_INSTALL_FULL_LIBDIR})
message(STATUS "CMAKE_MODULE_PATH: " ${CMAKE_MODULE_PATH})
message(STATUS "CMAKE_PREFIX_PATH: " ${CMAKE_PREFIX_PATH})
message(STATUS "TF_BUILD_BENCHMARKS: " ${TF_BUILD_BENCHMARKS})
message(STATUS "TF_BUILD_PROFILER: " ${TF_BUILD_PROFILER})
message(STATUS "TF_BUILD_CUDA: " ${TF_BUILD_CUDA})
message(STATUS "TF_BUILD_SYCL: " ${TF_BUILD_SYCL})
message(STATUS "TF_BUILD_SYCL_BITCODE: " ${TF_BUILD_SYCL_BITCODE})
message(STATUS "TF_BUILD_TESTS: " ${TF_BUILD_TESTS})
message(STATUS "TF_BUILD_EXAMPLES: " ${TF_BUILD_EXAMPLES})
message(STATUS "TF_UTEST_DIR: " ${TF_UTEST_DIR})
message(STATUS "TF_EXAMPLE_DIR: " ${TF_EXAMPLE_DIR})
message(STATUS "TF_BENCHMARK_DIR: " ${TF_BENCHMARK_DIR})
message(STATUS "TF_3RD_PARTY_DIR: " ${TF_3RD_PARTY_DIR})

# add the binary tree to the search path for include files
include_directories(${PROJECT_SOURCE_DIR})

# -----------------------------------------------------------------------------
# must-have package include
# -----------------------------------------------------------------------------

# Enable test
include(CTest)

# Find pthread package
find_package(Threads REQUIRED)

# -----------------------------------------------------------------------------
# Taskflow library interface
# -----------------------------------------------------------------------------

add_library(${PROJECT_NAME} INTERFACE)
target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_17)
target_link_libraries(${PROJECT_NAME} INTERFACE Threads::Threads)
target_include_directories(${PROJECT_NAME} INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:include/> 
)

# -----------------------------------------------------------------------------
# Example program 
# -----------------------------------------------------------------------------
if(TF_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif(TF_BUILD_EXAMPLES)

=== unittests/CMakeLists.txt ===
enable_testing()

include(${TF_3RD_PARTY_DIR}/doctest/doctest.cmake)

list(APPEND TF_UNITTESTS 
  test_utility 
  test_work_stealing 
  #test_serializer 
  test_priorities
  test_basics 
  test_asyncs
  test_dependent_asyncs
  test_subflows
  test_control_flow
  test_semaphores
  test_movable
  test_cancellation
  test_for_each
  test_reduce
  test_transform
  test_sort
  test_scan
  test_find
  test_compositions
  test_traversals
  test_pipelines
  test_scalable_pipelines
  test_deferred_pipelines
  test_deferred_scalable_pipelines
  test_runtimes
  test_data_pipelines
  test_workers
)

foreach(unittest IN LISTS TF_UNITTESTS)
  add_executable(${unittest} ${unittest}.cpp)
  target_link_libraries(${unittest} ${PROJECT_NAME} tf::default_settings)
  target_include_directories(${unittest} PRIVATE ${TF_3RD_PARTY_DIR}/doctest)
  doctest_discover_tests(${unittest})
endforeach()

# include CUDA tests
if(TF_BUILD_CUDA)
  add_subdirectory(${TF_UTEST_DIR}/cuda)
endif()

# include SYCL tests
if(TF_BUILD_SYCL)
  add_subdirectory(${TF_UTEST_DIR}/sycl)
endif()

=== examples/cuda/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# cuda examples
# -----------------------------------------------------------------------------

list(APPEND TF_CUDA_EXAMPLES 
  cuda_device_property 
  cuda_saxpy 
  cuda_matmul 
  cuda_knn
  cuda_capturer
  cuda_reduce
  cuda_scan
  cuda_merge
  cuda_sort
  cuda_transform
  cuda_rebind
  cuda_find
)

foreach(cuda_example IN LISTS TF_CUDA_EXAMPLES)
  add_executable(${cuda_example} ${cuda_example}.cu)
  target_link_libraries(${cuda_example}
    ${PROJECT_NAME} Threads::Threads tf::default_settings
  )

  # avoid cmake 3.18+ warning
  # we let nvcc to decide the flag if the architecture is not given
  if(NOT CUDA_ARCHITECTURES)
    set_property(TARGET ${cuda_example} PROPERTY CUDA_ARCHITECTURES OFF)
  endif()
endforeach()

=== examples/sycl/CMakeLists.txt ===
list(APPEND TF_SYCL_EXAMPLES 
  sycl_device
  sycl_ndrange
  sycl_saxpy
  sycl_vector_add
  sycl_atomic
  sycl_matmul
  sycl_reduce
)

foreach(sycl_example IN LISTS TF_SYCL_EXAMPLES)
  add_executable(${sycl_example} ${sycl_example}.cpp)

  #add_sycl_to_target(TARGET ${sycl_example} SOURCES ${sycl_example}.cpp)

  target_compile_options(${sycl_example} PRIVATE ${TF_SYCL_OPTIONS})
  target_link_options(${sycl_example} PRIVATE ${TF_SYCL_OPTIONS})
  target_link_libraries(${sycl_example}
    ${PROJECT_NAME} Threads::Threads tf::default_settings
  )
endforeach()

=== tfprof/server/CMakeLists.txt ===

add_executable(tfprof tfprof.cpp)

target_link_libraries(
  tfprof ${PROJECT_NAME} tf::default_settings
)

target_include_directories(tfprof PRIVATE ${TF_3RD_PARTY_DIR})

=== unittests/cuda/CMakeLists.txt ===

list(APPEND TF_CUDA_UNITTESTS 
  test_cuda_objects
  test_cuda_memory
  test_cuda_basics 
  test_cuda_matrix 
  test_cuda_kmeans 
  test_cuda_for_each
  test_cuda_for_each_index
  test_cuda_transform
  test_cuda_reduce
  test_cuda_scan
  test_cuda_find
  test_cuda_min_max_element
  test_cuda_merge
  test_cuda_basic_updates
  test_cuda_capturer_optimizer
  
  #cuda_algorithms
  #cuda_algorithm_updates
)

foreach(cudatest IN LISTS TF_CUDA_UNITTESTS)
  add_executable(${cudatest} ${cudatest}.cu)
  target_link_libraries(${cudatest} ${PROJECT_NAME} tf::default_settings)
  target_include_directories(${cudatest} PRIVATE ${TF_3RD_PARTY_DIR}/doctest)
  
  # avoid cmake 3.18+ warning
  # we let nvcc to decide the flag if the architecture is not given
  if(NOT CUDA_ARCHITECTURES)
    set_property(TARGET ${cudatest} PROPERTY CUDA_ARCHITECTURES OFF)
  endif()
  
  doctest_discover_tests(${cudatest})
endforeach()

=== unittests/sycl/CMakeLists.txt ===
list(APPEND TF_SYCL_TESTS 
  sycl_basics
  #sycl_algorithms
  #sycl_rebinds
)

foreach(sycl_test IN LISTS TF_SYCL_TESTS)
  add_executable(${sycl_test} ${sycl_test}.cpp)

  #add_sycl_to_target(TARGET ${sycl_test} SOURCES ${sycl_test}.cpp)

  target_compile_options(${sycl_test} PRIVATE ${TF_SYCL_OPTIONS})
  target_link_options(${sycl_test} PRIVATE ${TF_SYCL_OPTIONS})
  target_link_libraries(${sycl_test}
    ${PROJECT_NAME} Threads::Threads tf::default_settings
  )
  target_include_directories(${sycl_test} PRIVATE ${TF_3RD_PARTY_DIR}/doctest)
  
  doctest_discover_tests(${sycl_test})
endforeach()

=== debian/control ===
Source: taskflow
Section: libs
Priority: optional
Maintainer: Julian Gilbey <jdg@debian.org>
Uploaders: Debian Python Team <team+python@tracker.debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13)
Build-Depends-Arch: doctest-dev <!nocheck>,
                    libcli11-dev,
                    libcpp-httplib-dev,
                    libjs-bootstrap4,
                    libjs-d3-tip,
                    libjs-jquery,
                    libspdlog-dev,
                    nlohmann-json3-dev,
                    node-d3
Build-Depends-Indep: doxygen <!nodoc>,
                     graphviz <!nodoc>,
                     python3-jinja2 <!nodoc>,
                     python3-pygments <!nodoc>
Standards-Version: 4.7.0
Homepage: https://taskflow.github.io/
Vcs-Browser: https://salsa.debian.org/debian/taskflow
Vcs-Git: https://salsa.debian.org/debian/taskflow.git
Description: Parallel and Heterogeneous Task Programming System for C++
 Taskflow helps you quickly write parallel and heterogeneous task
 programs with high performance and simultaneous high productivity. It
 is faster, more expressive, with fewer lines of code, and easier for
 drop-in integration than many of existing task programming libraries.
 It is provided as a collection of C++ header files, using C++17.

Package: libtaskflow-cpp-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}
Suggests: taskflow-doc,
          taskflow-profiler
Description: ${source:Synopsis} (header files)
 ${source:Extended-Description}
 .
 This package provides the C++ header files for Taskflow.

Package: taskflow-profiler
Section: libdevel
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: libtaskflow-cpp-dev
Suggests: taskflow-doc
Description: ${source:Synopsis} (profiler)
 ${source:Extended-Description}
 .
 This package provides the Taskflow profiler, "tfprof", together with the
 profiler server.

Package: taskflow-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libtaskflow-cpp-dev,
          taskflow-profiler
Description: ${source:Synopsis} (documentation)
 ${source:Extended-Description}
 .
 This package provides the documentation for Taskflow.
Build-Profiles: <!nodoc>

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
# export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CXXFLAGS+=$(CPPFLAGS)

DEBIANDIR = $(shell pwd)/debian

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -a -- -D TF_BUILD_EXAMPLES=OFF \
	    -D TF_BUILD_TESTS=OFF -D TF_BUILD_PROFILER=ON

override_dh_auto_configure-indep:

execute_after_dh_auto_build-arch:
	# The profiler needs local copies of these libraries; it cannot
	# use symlinks
	mkdir -p tfprof/css/bootstrap/4.4.1
	cp /usr/share/nodejs/bootstrap/dist/css/bootstrap.min.css tfprof/css/bootstrap/4.4.1/bootstrap.min.css
	mkdir -p tfprof/js/bootstrap/4.4.1
	cp /usr/share/nodejs/bootstrap/dist/js/bootstrap.bundle.min.js* tfprof/js/bootstrap/4.4.1
	mkdir -p tfprof/js/jquery/3.4.1
	cp /usr/share/javascript/jquery/jquery.min.js tfprof/js/jquery/3.4.1/jquery.min.js
	mkdir -p tfprof/js/d3
	cp /usr/share/nodejs/d3/dist/d3.min.js tfprof/js/d3/d3.v5.min.js
	cp /usr/share/javascript/d3-tip/d3-tip.min.js tfprof/js/d3/d3-tip.min.js

override_dh_auto_build-indep:
	: # Dummy to force the target to always be run
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	# a continuation of override_dh_auto_build-indep: build documentation
	cd mcss/documentation && ./doxygen.py ../../doxygen/conf.py
	cp debian/source-fonts.css docs
	mkdir docs/fonts
	for font in \
	    Source_Code_Pro/static/SourceCodePro-Italic.ttf \
	    Source_Code_Pro/static/SourceCodePro-Regular.ttf \
	    Source_Code_Pro/static/SourceCodePro-SemiBold.ttf \
	    Source_Sans_Pro/SourceSansPro-Regular.ttf \
	    Source_Sans_Pro/SourceSansPro-SemiboldItalic.ttf \
	    Source_Sans_Pro/SourceSansPro-Semibold.ttf \
	    Source_Sans_Pro/SourceSansPro-Italic.ttf; do \
	    cp source-fonts/$$font docs/fonts; \
	done
	perl -i -pe 's$$\Qhref="https://fonts.googleapis.com/css?family=source+sans+pro:400,400i,600,600i%7csource+code+pro:400,400i,600"\E$$href="source-fonts.css"$$i' docs/*.html
	perl -i -pe "s% ((?:body)?file)=\"\Q$$(pwd)\E% $$1=\"/usr/include%g; s% external=\"\Q$$(pwd)\E/doxygen/% external=\"%g;" docs/xml/*.xml
endif

override_dh_compress-indep:
	# These are all referred to by HTML pages in the documentation,
	# so should not be compressed
	dh_compress -X.dot -X.pdf -X.xml -X.xsd -X.ttf

override_dh_auto_test-arch:
	: # Dummy to force the target to alway be run
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -p buildtest
	cd buildtest && cmake ../ -D TF_BUILD_EXAMPLES=OFF \
	    -D TF_BUILD_PROFILER=OFF -D TF_BUILD_TESTS=ON
	cd buildtest && make
	cd buildtest && make test || \
	    make test ARGS="--rerun-failed --output-on-failure"
endif

override_dh_auto_test-indep:

execute_before_dh_clean:
	rm -rf mcss/documentation/__pycache__ mcss/plugins/__pycache__
	rm -rf doxygen/__pycache__
	rm -rf buildtest
	rm -rf docs
	rm -rf tfprof/css/bootstrap tfprof/js/bootstrap tfprof/js/jquery tfprof/js/d3

=== debian/tests/control ===
Tests: taskflow-tests
Depends: cmake,
         doctest-dev,
         g++,
         libtaskflow-cpp-dev
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%, \
      dversionmangle=s/\+ds//, \
      repack, repacksuffix=+ds" \
    https://github.com/taskflow/taskflow/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@

## taskflow 3.7.0+ds

=== unittests/CMakeLists.txt ===
--- 
+++ 
@@ -29,8 +29,16 @@
   test_deferred_scalable_pipelines
   test_runtimes
   test_data_pipelines
-  test_workers
 )
+
+string(FIND '${CMAKE_CXX_FLAGS}' "-fsanitize" sanitize)
+#message("sanitize='${sanitize}'")
+
+if(${sanitize} EQUAL -1)
+  message(STATUS "Add test_exception to unit tests")
+  list(APPEND TF_UNITTESTS test_exceptions)
+endif()
+
 
 foreach(unittest IN LISTS TF_UNITTESTS)
   add_executable(${unittest} ${unittest}.cpp)

=== unittests/cuda/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
   test_cuda_merge
   test_cuda_basic_updates
   test_cuda_capturer_optimizer
+  test_cuda_capture
   
   #cuda_algorithms
   #cuda_algorithm_updates

=== debian/changelog ===
taskflow (3.7.0+ds-3deepin0) unstable; urgency=medium

  * No source change upload against GCC 12.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 20 Sep 2024 12:19:48 +0800

taskflow (3.7.0+ds-3) unstable; urgency=medium

  * Fix autopkgtest to use libatomic on armel

 -- Julian Gilbey <jdg@debian.org>  Thu, 04 Jul 2024 21:03:18 +0100

taskflow (3.7.0+ds-2) unstable; urgency=medium

  * Fix tests on archs where size_t is only 32 bits

 -- Julian Gilbey <jdg@debian.org>  Tue, 02 Jul 2024 13:57:42 +0100

taskflow (3.7.0+ds-1) unstable; urgency=medium

  * New upstream version
  * Add Multi-Arch hints

 -- Julian Gilbey <jdg@debian.org>  Mon, 01 Jul 2024 21:57:30 +0100

=== debian/control ===
--- 
+++ 
@@ -33,6 +33,7 @@
 Package: libtaskflow-cpp-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}
 Suggests: taskflow-doc,
           taskflow-profiler
@@ -58,6 +59,7 @@
 Package: taskflow-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Suggests: libtaskflow-cpp-dev,
           taskflow-profiler

## taskflow 3.8.0+ds

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
   async
   subflow_async
   dependent_async
+  dependent_async_algorithm
   observer 
   subflow 
   fibonacci 
@@ -14,7 +15,6 @@
   while_loop
   if_else
   nested_if_else
-  priority
   visualization 
   parallel_for 
   parallel_sort
@@ -32,16 +32,16 @@
   run 
   corun
   runtime
-  worker_interface
   composition
   limited_concurrency
   cancel
+  exception
 )
 
 foreach(example IN LISTS TF_EXAMPLES)
   add_executable(${example} ${example}.cpp)
   target_link_libraries(
-    ${example} ${PROJECT_NAME} tf::default_settings
+    ${example} ${PROJECT_NAME} ${ATOMIC_LIBRARY} tf::default_settings
     )
   # set emcc options
   if (CMAKE_SYSTEM_NAME STREQUAL Emscripten)

=== unittests/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,10 @@
 
 list(APPEND TF_UNITTESTS 
   test_utility 
+  test_queue
   test_work_stealing 
   #test_serializer 
-  test_priorities
+  #test_priorities
   test_basics 
   test_asyncs
   test_dependent_asyncs
@@ -42,7 +43,7 @@
 
 foreach(unittest IN LISTS TF_UNITTESTS)
   add_executable(${unittest} ${unittest}.cpp)
-  target_link_libraries(${unittest} ${PROJECT_NAME} tf::default_settings)
+  target_link_libraries(${unittest} ${PROJECT_NAME} ${ATOMIC_LIBRARY} tf::default_settings)
   target_include_directories(${unittest} PRIVATE ${TF_3RD_PARTY_DIR}/doctest)
   doctest_discover_tests(${unittest})
 endforeach()

=== debian/changelog ===
taskflow (3.8.0+ds-1) unstable; urgency=medium

  * New upstream version

 -- Julian Gilbey <jdg@debian.org>  Thu, 07 Nov 2024 21:31:21 +0000

## taskflow 3.9.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,11 @@
 #
 # To enable address and leak sanitizers
 # -DCMAKE_CXX_FLAGS="-fsanitize=address  -fsanitize=leak -g"
+#
+# To enable different c++ standards
+# -DCMAKE_CXX_STANDARD=17
+# -DCMAKE_CXX_STANDARD=20
+# -DCMAKE_CXX_STANDARD=23
 # -------------------------------------------------------------------
 
 
@@ -14,10 +19,11 @@
 MESSAGE(STATUS "CMAKE_ROOT: " ${CMAKE_ROOT})
 
 # Project name
-project(Taskflow VERSION 3.6.0 LANGUAGES CXX)
+project(Taskflow VERSION 3.9.0 LANGUAGES CXX)
 
 # build options
 option(TF_BUILD_BENCHMARKS "Enables builds of benchmarks" OFF)
+option(TF_BUILD_PROFILER "Enables builds of profiler" OFF)
 option(TF_BUILD_CUDA "Enables builds of cuda code" OFF)
 option(TF_BUILD_SYCL "Enables builds of sycl code" OFF)
 option(TF_BUILD_TESTS "Enables builds of tests" ON)
@@ -40,12 +46,15 @@
 # Adhere to GNU conventions
 include(GNUInstallDirs)
 
+# Check for correct settings for atomic library
+include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Atomic/CheckAtomic.cmake)
+
 # Compiler vendors
 ## g++
 if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
-  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "7.0")
+  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.4")
     message(STATUS "CMAKE_CXX_COMPILER_VERSION: ${CMAKE_CXX_COMPILER_VERSION}")
-    message(FATAL_ERROR "\nTaskflow requires g++ at least v7.0")
+    message(FATAL_ERROR "\nTaskflow requires g++ at least v8.4")
   endif()
 ## clang++
 elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
@@ -55,8 +64,8 @@
   endif() 
 ## AppleClang
 elseif (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
-  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.0")
-    message(FATAL_ERROR "\nTaskflow requires AppleClang at least v8.0")
+  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "12.0")
+    message(FATAL_ERROR "\nTaskflow requires AppleClang at least v12.0")
   endif()
 ## microsoft visual c++
 elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
@@ -132,7 +141,7 @@
 #endif()
 
 # -----------------------------------------------------------------------------
-# defult release build
+# default to release build, unless explicitly specified
 # -----------------------------------------------------------------------------
 if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   message(STATUS "Setting build type to '${TF_DEFAULT_BUILD_TYPE}'")
@@ -163,9 +172,9 @@
 target_compile_options(
   error_settings
   INTERFACE
-  $<$<CXX_COMPILER_ID:AppleClang>:-Wall -Wextra -Wfatal-errors>
-  $<$<AND:$<COMPILE_LANGUAGE:CXX>,$<CXX_COMPILER_ID:Clang>>:-Wall -Wextra -Wfatal-errors>
-  $<$<AND:$<COMPILE_LANGUAGE:CXX>,$<CXX_COMPILER_ID:GNU>>:-Wall -Wextra -Wfatal-errors>
+  $<$<CXX_COMPILER_ID:AppleClang>:-Wall -Wextra -Wfatal-errors -Wshadow>
+  $<$<AND:$<COMPILE_LANGUAGE:CXX>,$<CXX_COMPILER_ID:Clang>>:-Wall -Wextra -Wfatal-errors -Wshadow>
+  $<$<AND:$<COMPILE_LANGUAGE:CXX>,$<CXX_COMPILER_ID:GNU>>:-Wall -Wextra -Wfatal-errors -Wshadow>
   $<$<AND:$<COMPILE_LANGUAGE:CXX>,$<CXX_COMPILER_ID:MSVC>>:/W3 /permissive->
 )
 
@@ -176,7 +185,7 @@
     error_settings
     BEFORE
     INTERFACE
-    $<$<COMPILE_LANGUAGE:CUDA>:--extended-lambda -Xcompiler=-Wall,-Wextra,-Wfatal-errors>
+    $<$<COMPILE_LANGUAGE:CUDA>:--extended-lambda -Xcompiler=-Wall,-Wextra,-Wfatal-errors,-Wshadow>
   )
 endif(TF_BUILD_CUDA)
 
@@ -243,14 +252,18 @@
 message(STATUS "PROJECT_NAME: " ${PROJECT_NAME})
 message(STATUS "CMAKE_HOST_SYSTEM: ${CMAKE_HOST_SYSTEM}")
 message(STATUS "CMAKE_BUILD_TYPE: " ${CMAKE_BUILD_TYPE})
+message(STATUS "CMAKE_SYSTEM: " ${CMAKE_SYSTEM})
+message(STATUS "CMAKE_SYSTEM_PROCESSOR: " ${CMAKE_SYSTEM_PROCESSOR})
 message(STATUS "CMAKE_CXX_COMPILER: " ${CMAKE_CXX_COMPILER})
 message(STATUS "CMAKE_CXX_COMPILER_ID: " ${CMAKE_CXX_COMPILER_ID})
 message(STATUS "CMAKE_CXX_COMPILER_VERSION: " ${CMAKE_CXX_COMPILER_VERSION})
 message(STATUS "CMAKE_CXX_FLAGS: " ${CMAKE_CXX_FLAGS})
+message(STATUS "CMAKE_CXX_STANDARD: " ${CMAKE_CXX_STANDARD})
 message(STATUS "CMAKE_CUDA_COMPILER: " ${CMAKE_CUDA_COMPILER})
 message(STATUS "CMAKE_CUDA_COMPILER_ID: " ${CMAKE_CUDA_COMPILER_ID})
 message(STATUS "CMAKE_CUDA_COMPILER_VERSION: " ${CMAKE_CUDA_COMPILER_VERSION})
 message(STATUS "CMAKE_CUDA_FLAGS: " ${CMAKE_CUDA_FLAGS})
+message(STATUS "CMAKE_CUDA_STANDARD: " ${CMAKE_CUDA_STANDARD})
 message(STATUS "CMAKE_MODULE_PATH: " ${CMAKE_MODULE_PATH})
 message(STATUS "CMAKE_CURRENT_SOURCE_DIR: " ${CMAKE_CURRENT_SOURCE_DIR})
 message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})
@@ -280,28 +293,8 @@
 # must-have package include
 # -----------------------------------------------------------------------------
 
-# Enable test
-include(CTest)
-
 # Find pthread package
 find_package(Threads REQUIRED)
 
 # -----------------------------------------------------------------------------
 # Taskflow library interface
-# -----------------------------------------------------------------------------
-
-add_library(${PROJECT_NAME} INTERFACE)
-target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_17)
-target_link_libraries(${PROJECT_NAME} INTERFACE Threads::Threads)
-target_include_directories(${PROJECT_NAME} INTERFACE
-  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
-  $<INSTALL_INTERFACE:include/> 
-)
-
-# -----------------------------------------------------------------------------
-# Example program 
-# -----------------------------------------------------------------------------
-if(TF_BUILD_EXAMPLES)
-  add_subdirectory(examples)
-endif(TF_BUILD_EXAMPLES)
-

=== documentation/test_python/CMakeLists.txt ===
#
#   This file is part of m.css.
#
#   Copyright © 2017, 2018, 2019, 2020, 2021, 2022, 2023
#             Vladimír Vondruš <mosra@centrum.cz>
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included
#   in all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#

cmake_minimum_required(VERSION 3.5)
project(McssDocumentationPybindTests)

find_package(pybind11 CONFIG REQUIRED)

foreach(target pybind_signatures pybind_enums pybind_external_overload_docs pybind_submodules pybind_type_links search_long_suffix_length)
    pybind11_add_module(${target} ${target}/${target}.cpp)
    set_target_properties(${target} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${target})
endforeach()

# Need a special location for this one
pybind11_add_module(pybind_inspect_create_intersphinx inspect_create_intersphinx/inspect_create_intersphinx/pybind.cpp)
set_target_properties(pybind_inspect_create_intersphinx PROPERTIES
    OUTPUT_NAME pybind
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/inspect_create_intersphinx/inspect_create_intersphinx)

# Need a special location for this one
pybind11_add_module(pybind_link_formatting link_formatting/link_formatting/pybind.cpp)
set_target_properties(pybind_link_formatting PROPERTIES
    OUTPUT_NAME pybind
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/link_formatting/link_formatting)

# Need a special location for this one
pybind11_add_module(pybind_search search/search/pybind.cpp)
set_target_properties(pybind_search PROPERTIES
    OUTPUT_NAME pybind
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/search/search)

# Need a special name for this one
pybind11_add_module(pybind_name_mapping pybind_name_mapping/sub.cpp)
set_target_properties(pybind_name_mapping PROPERTIES
    OUTPUT_NAME _sub
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/pybind_name_mapping/pybind_name_mapping)

# Need a special name for this one
pybind11_add_module(pybind_submodules_package pybind_submodules_package/sub.cpp)
set_target_properties(pybind_submodules_package PROPERTIES
    OUTPUT_NAME sub
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/pybind_submodules_package/pybind_submodules_package)

=== examples/sycl/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,6 @@
   target_compile_options(${sycl_example} PRIVATE ${TF_SYCL_OPTIONS})
   target_link_options(${sycl_example} PRIVATE ${TF_SYCL_OPTIONS})
   target_link_libraries(${sycl_example}
-    ${PROJECT_NAME} Threads::Threads tf::default_settings
+    ${PROJECT_NAME} ${ATOMIC_LIBRARY} Threads::Threads tf::default_settings
   )
 endforeach()

=== documentation/test_doxygen/example/path-prefix/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/configure.h.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/configure.h)

add_executable(app main.cpp)
target_include_directories(app ${CMAKE_CURRENT_BINARY_DIR})

=== debian/changelog ===
taskflow (3.9.0+ds-1ubuntu1) resolute; urgency=medium

  * d/control: reduce to archs for cpp-httplib

 -- Mario Limonciello <superm1@debian.org>  Mon, 23 Feb 2026 12:25:51 -0600

taskflow (3.9.0+ds-1build2) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 29 Jan 2026 21:32:31 +0100

taskflow (3.9.0+ds-1build1) plucky; urgency=medium

  * Rebuild against latest cpp-httplib

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 16 Mar 2025 08:19:36 -0400

taskflow (3.9.0+ds-1) unstable; urgency=medium

  * New upstream version
  * Switch Maintainer and Uploaders so maintainer is now DPT

 -- Julian Gilbey <jdg@debian.org>  Sun, 16 Feb 2025 18:55:40 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: taskflow
 Section: libs
 Priority: optional
-Maintainer: Julian Gilbey <jdg@debian.org>
-Uploaders: Debian Python Team <team+python@tracker.debian.org>
+Maintainer: Debian Python Team <team+python@tracker.debian.org>
+Uploaders: Julian Gilbey <jdg@debian.org>
 Rules-Requires-Root: no
 Build-Depends: cmake,
                debhelper-compat (= 13)
@@ -32,7 +32,7 @@
 
 Package: libtaskflow-cpp-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 ppc64el s390x
 Multi-Arch: same
 Depends: ${misc:Depends}
 Suggests: taskflow-doc,
@@ -44,7 +44,7 @@
 
 Package: taskflow-profiler
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 ppc64el s390x
 Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${shlibs:Depends}
